//*****************************************************************************
//*
//*
//*		DspZipper.cpp
//*
//*
//*****************************************************************************
//
//	(C) Copyright Anton Zechner 2007
//
//	Zippt Visual-Studio-Projekte.
//
#include "StdAfx.h"
#include "RegConfig.h"

#define CPP_FILTER1	"*.exe;*.obj;*.idb;*.aps;*.ncb;*.sdf;*.opt;*.plg;*.pdb;*.aps;*.pch;*.res;*.ilk;*.sbr;*.map;*.mp3;*.wav;*.bsc;*.gid;*.dll;*.fts;*.ftg;*.sav;*.00*;*.tmp;*.enc;*.tlb;*.tli;*.tlh;*.dat;*.mdb;*.gid;*.ftg;*.aps;*.cfd;*.exd;*.am;*.asp;*.exp;*.rtb;*.loc;*.sup;*.cvsignore;*.cnv;*.jar;*.icu;*.stub;*.policy;*.log;*.suo;*.keep;*.keep.?;*.keep.??;*.sql;BuildLog.htm;*.embed.manifest;*.intermediate.manifest;*.user;*.svn-base;*.;*.zip.bin;*.d;*.crf;*.axf;*.__i;*.o;*.bak;*.uvgui;*.uvgui.*;*_dummy.dsw;*_dummy.dsp;*.tra;*.sct;*.lnp;*.iex;*.dep;*.lst;*.uvgui.*;*.pbi;*.pbd;*.cout;*.browse;*.sim;*.out;*.dep;*._ia;*.scc;*.sbr;*.rsp;*.mac;*.tli;*.tlh;*.keep;*.tlog;*.lastbuildstate;*.ipch;*.lib"
#define CPP_FILTER2	"*.exe;*.obj;*.idb;*.aps;*.ncb;*.sdf;*.opt;*.plg;*.pdb;*.aps;*.pch;*.res;*.ilk;*.sbr;*.map;*.mp3;*.wav;*.bsc;*.gid;*.dll;*.fts;*.ftg;*.sav;*.00*;*.tmp;*.enc;*.tlb;*.tli;*.tlh;*.dat;*.mdb;*.gid;*.ftg;*.aps;*.cfd;*.exd;*.am;*.asp;*.exp;*.rtb;*.loc;*.sup;*.cvsignore;*.cnv;*.jar;*.icu;*.stub;*.policy;*.log;*.suo;*.keep;*.keep.?;*.keep.??;*.sql;BuildLog.htm;*.embed.manifest;*.intermediate.manifest;*.user;*.svn-base;*.;*.zip.bin;*.d;*.crf;*.axf;*.__i;*.o;*.bak;*.uvgui;*.uvgui.*;*_dummy.dsw;*_dummy.dsp;*.tra;*.sct;*.lnp;*.iex;*.dep;*.lst;*.uvgui.*;*.pbi;*.pbd;*.cout;*.browse;*.sim;*.out;*.dep;*._ia;*.scc;*.sbr;*.rsp;*.mac;*.tli;*.tlh;*.keep;*.tlog;*.lastbuildstate;*.ipch"


//*****************************************************************************
//*
//*		main
//*
//*****************************************************************************
int main(int argc, char **argv)
{
char		path[MAX_PATH],name[MAX_PATH],temp[MAX_PATH];
char		filter[1024];
int			type,pos,ok,i;
CZipFile	zip;


	if(argc<2)
		{
		printf("\n\n  Syntax:   DspZipper  Pfad [ZipName] [-c]\n");
		printf("\n               Pfad    : Von dort werden alle C++ Projektdateien kopiert.");
		printf("\n               ZipName : Ziel Zipdatei.");
		printf("\n               -c      : Programm fr Explorer konfigurieren.\n\n");

		#ifdef 	_DEBUG
		getch();
		#endif
		return -1;
		}

	for(i=1;i<argc;i++)
		{
		if(stricmp(argv[i],"-c"))continue;

		GetExeName(path,sizeof(path));

		ConfigFileCommand("DSP"    ,path,"Projekt zippen");
		ConfigFileCommand("DSW"	   ,path,"Projekt zippen");
		ConfigFileCommand("SLN"    ,path,"Projekt zippen");
		ConfigFileCommand("EWW"    ,path,"Projekt zippen");
		ConfigFileCommand("EWP"    ,path,"Projekt zippen");
		ConfigFileCommand("UV2"    ,path,"Projekt zippen");
		ConfigFileCommand("UVPROJ" ,path,"Projekt zippen");
		ConfigFileCommand("UVPROJX",path,"Projekt zippen");
		ConfigFileCommand("VCPROJ" ,path,"Projekt zippen");

		return 1;
		}


	strlcpy(path,argv[1],sizeof(path));
	type=ExistFile(path);
	if(type!=1 && type!=2)
		{
		printf("\n\n   Der Pfad\n   '%s'\n   wurde nicht gefunden !\n\n",path);
		#ifdef 	_DEBUG
		getch();
		#endif
		return -1;
		}

	DelBackSlash(path);

	if(argc>=3)
		{
		strlcpy(name,argv[2],sizeof(name));
		}
	else{
		strlcpy(name,GetFileName(path),sizeof(name));
		}

	if(type==1)SubFileName(path);
	DelBackSlash(path);
	GetFileName(filter,path,sizeof(filter));
	AddBackSlash(path);
	strcat(filter,"*.zip;");


	if(CmpFileType(argv[1],"UVPROJ;UVPROJX"))
			strcat(filter,CPP_FILTER2);
	else	strcat(filter,CPP_FILTER1);

	pos=strcspn(name,"\\/");
	if(!name[pos])
		{
		strlcpy(temp,path,sizeof(temp));
		strlcat(temp,name,sizeof(temp));
		strlcpy(name,temp,sizeof(name));
		}

	SetFileType(name,"zip",sizeof(name));
	if(zip.Open(name,CAF_CREATE)!=CAF_ERROR_OK)
		{
		printf("\n\n   Die ZipDatei\n   '%s'\n   konnte nicht erzeugt werden !\n\n",name);
		#ifdef 	_DEBUG
		getch();
		#endif
		return -1;
		}

	   zip.Flags(CAF_FLAG_SUBDIR|zip.Flags());
	ok=zip.Add(path,"*",filter);
	if(ok<0)
		{
		printf("\n\n   Es gab einen Fehler bein einfgen der Dateien!\n\n");
		#ifdef 	_DEBUG
		getch();
		#endif
		return -1;
		}

	zip.Close();
	printf("\n\n   Es wurden %i Datei ein eingefuegt!\n\n",ok);

	#ifdef 	_DEBUG
	getch();
	#endif

return 0;
}
